from PyQt5 import QtGui
from PyQt5.QtWidgets import QApplication, QMainWindow, QGraphicsScene, QGraphicsView, QGraphicsItem, QGraphicsPixmapItem, QGraphicsTextItem, QGraphicsEffect, QGraphicsOpacityEffect, QGraphicsColorizeEffect
from PyQt5.QtGui import QPixmap, QPainter, QColor
from PyQt5.Qt import Qt
 
import sys
 
class Window(QMainWindow):
    def __init__(self):
        super().__init__()
 
        self.title = "Эффекты"
        self.top = 200
        self.left = 500
        self.width = 400
        self.height = 400

        # Флаг для выбора эффекта
        self.flag = True
        
        self.setWindowTitle(self.title)
        # Задание местоположения и размера окна
        self.setGeometry(self.left, self.top, self.width, self.height)
        # Создание графической сцены
        self.scene = QGraphicsScene()
        # Создание инструмента для отрисовки графической сцены
        self.graphicView = QGraphicsView(self.scene, self)
        # Задание местоположения и размера графической сцены
        self.graphicView.setGeometry(0, 0, self.width, self.height)

    def keyPressEvent(self, event):
        # Обработчик нажатия клавиш
        self.flag = not self.flag
        if self.flag == True:
            # Задание изменения цвета
            clr = QGraphicsColorizeEffect()
            clr.setColor(QColor(140, 50, 255))
            # Добавление эффекта к объекту
            self.image.setGraphicsEffect(clr)
        else:
            # Прозрачность и его параметры
            op = QGraphicsOpacityEffect()
            op.setOpacity(0.3)
            # Добавление эффекта к объекту
            self.image.setGraphicsEffect(op)
        event.accept() # Завершение обработки события
        
    def plot(self):
        # Создание объекта QPixmap
        self.picture = QPixmap('IMG2.jpg')
        # Создание "пустого" объекта QGraphicsPixmapItem
        self.image = QGraphicsPixmapItem()
        # Задание изображения в объект QGraphicsPixmapItem
        self.image.setPixmap(self.picture)
        # Позиция объекта QGraphicsPixmapItem
        self.image.setOffset(0, 0)
        # Добавление объекта QGraphicsPixmapItem на сцену
        self.scene.addItem(self.image)


App = QApplication(sys.argv)
window = Window()
window.show() # Демонстрация окна
window.plot() # Построение и перерисовка окна

sys.exit(App.exec())
